
%%% liczby-send-select.pl

%%% Prosty program ilustruj±cy ideê generacji/wyszukiwania rozwi±zañ w Prologu


% Fakty: definicja dostępnych cyfr. 
 cyfry([0,1,2,3,4,5,6,7,8,9]).


find(X,Y,Z):- cyfry(L),
              select(X,L,LX),
              select(Y,LX,LY),
              select(Z,LY,_),
 Z is X+Y,
 S is X+Y+Z,
 S==6.


solve_down:-
   cyfry(L),
   select(E,L,LE),
    select(M,LE,LM), select(N,LM,LN), select(O,LN,LO),
   select(S,LO,LS), select(Y,LS,LY), select(D,LY,LD), select(R,LD,_),M>0,
   L1 is S*1000 + E*100 + N*10 + D, 
     L2 is M*1000 + O*100 + R*10 + E, 
     L3 is M*10000 + O*1000 + N*100 + E*10 + Y,
     Q is (L1 + L2) - L3, % write(Q),nl,
     Q = 0,
     write(' '),write(S),write(E),write(N),write(D),nl,
     write('+'),write(M),write(O),write(R),write(E),nl,
     write(M),write(O),write(N),write(E),write(Y).

solve_up:-
   cyfry(L),
   select(S,L,LS), select(Y,LS,LY), select(D,LY,LD), select(R,LD,LR),
   select(N,LR,LN), select(O,LN,LO), select(M,LO,LM),
   select(E,LM,_), M>0, 
    L1 is S*1000 + E*100 + N*10 + D, 
     L2 is M*1000 + O*100 + R*10 + E, 
     L3 is M*10000 + O*1000 + N*100 + E*10 + Y,
     Q is (L1 + L2) - L3, % write(Q),nl,
     Q = 0,
     write(' '),write(S),write(E),write(N),write(D),nl,
     write('+'),write(M),write(O),write(R),write(E),nl,
     write(M),write(O),write(N),write(E),write(Y).
   







% Rozwiazanie dla problemu SEND + MORE = MONEY
   solve :-
      cyfry(L),
      select(S,L,LS), select(E,LS,LE), select(N,LE,LN), select(D,LN,LD),
      select(M,LD,LM), 
      select(O,LM,LO), select(R,LO,LR), select(Y,LR,_),M>0,
     L1 is S*1000 + E*100 + N*10 + D, 
     L2 is M*1000 + O*100 + R*10 + E, 
     L3 is M*10000 + O*1000 + N*100 + E*10 + Y,
     Q is (L1 + L2) - L3, % write(Q),nl,
     Q = 0,
     write(' '),write(S),write(E),write(N),write(D),nl,
     write('+'),write(M),write(O),write(R),write(E),nl,
     write(M),write(O),write(N),write(E),write(Y).

% Modyfikacje:
% 1. Podstawianie za zmiennegotowych  warto¶ci. Np. M=1 zamiast c(M).
% 2. Zmiana kolejno¶ci podstawieñ i ograniczeñ (przeplatanie).
% 3. Pobieranie warto¶ci z listy z usuwaniem pobranych warto¶ci.
% 4. Wprowadzenie nowych regu³ ograniczeñ.

% eof
