
%%% liczby-send.pl

%%% Prosty program ilustrujący ideę generacji/wyszukiwania rozwiązań w Prologu
%%% i zastosowania do generowania całkowitoliczbowych 

% Fakty: definicja dostępnych cyfr. 
   cyfra(0).
   cyfra(1).
   cyfra(2).
   cyfra(3).
   cyfra(4).
   cyfra(5).   
   cyfra(6).
   cyfra(7).
   cyfra(8).
   cyfra(9).

% Skrót nazwy predykatu cyfra/1.
   c(X) :- cyfra(X).

cl(X):- select(X,[0,1,2,3,4,5,6,7,8,9],_).

% Rozwiązanie dla problemu SEND + MORE = MONEY
   solve :-
    c(M),M > 0, c(S),c(E),  c(N), c(D),  c(M),  c(O),   c(R),   c(Y), 
      S \= E, S \= N, S \= D, S \= M, S \= O, S \= R, S \= Y,
              E \= N, E \= D, E \= M, E \= O, E \= R, E \= Y,
                      N \= D, N \= M, N \= O, N \= R, N \= Y,
                              D \= M, D \= O, D \= R, D \= Y,
                                      M \= O, M \= R, M \= Y,
                                              O \= R, O \= Y,
                                                      R \= Y,
     L1 is S*1000 + E*100 + N*10 + D, 
     L2 is M*1000 + O*100 + R*10 + E, 
     L3 is M*10000 + O*1000 + N*100 + E*10 + Y,
     Q is (L1 + L2) - L3, % write(Q),nl,
     Q = 0,
     write(' '),write(S),write(E),write(N),write(D),nl,
     write('+'),write(M),write(O),write(R),write(E),nl,
     write(M),write(O),write(N),write(E),write(Y).

% Modyfikacje:
% 1. Podstawianie za zmienne gotowych  wartości. Np. M=1 zamiast c(M).
% 2. Zmiana kolejności podstawień i ograniczeń (przeplatanie).
% 3. Pobieranie wartości z listy z usuwaniem pobranych wartości.
% 4. Wprowadzenie nowych reguł ograniczeñ.

% eof
