% Source: http://clip.dia.fi.upm.es/~vocal/public_info/seminar_notes/node13.html

smm :-
        X = [S,E,N,D,M,O,R,Y],
        Digits = [0,1,2,3,4,5,6,7,8,9],
        assign_digits(X, Digits),
        M > 0, 
        S > 0,
                  1000*S + 100*E + 10*N + D +
                  1000*M + 100*O + 10*R + E =:=
        10000*M + 1000*O + 100*N + 10*E + Y,
        write(X).
        
select(X, [X|R], R).
select(X, [Y|Xs], [Y|Ys]):- select(X, Xs, Ys).

assign_digits([], _List).
assign_digits([D|Ds], List):-
        select(D, List, NewList),
        assign_digits(Ds, NewList).



smm5 :-
        Cars = [0,1],
        C = [C1,C2,C3,C4],
        assign_cars(C,Cars),
        X = [S,E,N,D,M,O,R,Y],
        Digits = [0,1,2,3,4,5,6,7,8,9],
        assign_digits(X, Digits),
        M > 0, 
        S > 0,
        
    M = C4,
    S > 0,
    M > 0,
    0 is 10*C1 + Y - D - E,
    0 is 10*C2 + E - N - R - C1, 
    0 is 10*C3 + N - E - O - C2,
    0 is 10*C4 + O - S - M - C3,
    write(X).
    
assign_cars([], _List).
assign_cars([D|Ds], List):-
        member(D, List),
        assign_cars(Ds, List).


 /*       
                  

*/
